<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <title>Array Cardio</title>
  </head>
  <body>
    <p><em>Psst: have a look at the JavaScript Console</em> 💁</p>

    <script>
      const inventors = [
        { first: "Albert", last: "Einstein", year: 1879, passed: 1955 },
        { first: "Isaac", last: "Newton", year: 1643, passed: 1727 },
        { first: "Galileo", last: "Galilei", year: 1564, passed: 1642 },
        { first: "Marie", last: "Curie", year: 1867, passed: 1934 },
        { first: "Johannes", last: "Kepler", year: 1571, passed: 1630 },
        { first: "Nicolaus", last: "Copernicus", year: 1858, passed: 1543 },
        { first: "Max", last: "Planck", year: 1858, passed: 1947 },
        { first: "Katherine", last: "Blodgett", year: 1898, passed: 1979 },
        { first: "Ada", last: "Lovelace", year: 1815, passed: 1852 },
        { first: "Sarah E.", last: "Goode", year: 1829, passed: 1905 },
        { first: "Lise", last: "Meitner", year: 1829, passed: 1968 },
        { first: "Hanna", last: "Hammarström", year: 1829, passed: 1909 },
      ];

      const people = [
        "Beck, Glenn",
        "Becker, Carl",
        "Beckett, Samuel",
        "Beddoes, Mick",
        "Beecher, Henry",
        "Beethoven, Ludwig",
        "Begin, Menachem",
        "Belloc, Hilaire",
        "Bellow, Saul",
        "Benchley, Robert",
        "Benenson, Peter",
        "Ben-Gurion, David",
        "Benjamin, Walter",
        "Benn, Tony",
        "Bennington, Chester",
        "Benson, Leana",
        "Bent, Silas",
        "Bentsen, Lloyd",
        "Berger, Ric",
        "Bergman, Ingmar",
        "Berio, Luciano",
        "Berle, Milton",
        "Berlin, Irving",
        "Berne, Eric",
        "Bernhard, Sandra",
        "Berra, Yogi",
        "Berry, Halle",
        "Berry, Wendell",
        "Bethea, Erin",
        "Bevan, Aneurin",
        "Bevel, Ken",
        "Biden, Joseph",
        "Bierce, Ambrose",
        "Biko, Steve",
        "Billings, Josh",
        "Biondo, Frank",
        "Birrell, Augustine",
        "Black, Elk",
        "Blair, Robert",
        "Blair, Tony",
        "Blake, William",
      ];

      // Array.prototype.filter()
      // 1. Filter the list of inventors for those who were born in the 1500's
      // if it returns true you keep it otherwise it will drop it

      let filteredInventors = inventors.filter(function (inventor) {
        if (1500 <= inventor.year && inventor.year < 1600) return true;
        return false;
      });
      // console.log(filteredInventors);

      // Array.prototype.map()
      // 2. Give us an array of the inventors' first and last names

      let mapedInventors = inventors.map((inventor) => "" + inventor.first + " " + inventor.last);
      // console.log(mapedInventors);

      // Array.prototype.sort()
      // 3. Sort the inventors by birthdate, oldest to youngest
      // let sortedInventors = inventors.sort((a, b) => a.year - b.year);
      const sortedInventors = inventors.sort((a, b) => {
        const property = "year";
        if (a[property] < b[property]) return -1;
        else if (a[property] > b[property]) return 1;
        else return 0;
      });

      // console.log(sortedInventors);

      // Array.prototype.reduce()
      // 4. How many years did all the inventors live?
      // let reducedInventors = inventors.map((inventor) => inventor.passed - inventor.year).reduce((p, c) => p + c);
      let reducedInventors = inventors.reduce((total, inventor) => total + (inventor.passed - inventor.year), 0);
      // console.log(reducedInventors);

      // 5. Sort the inventors by years lived
      let yearSortedInventors = inventors.sort((a, b) => a.passed - a.year - (b.passed - b.year));
      // console.log(yearSortedInventors);

      // 6. create a list of Boulevards in Paris that contain 'de' anywhere in the name
      let des = people.filter((person) => person.includes("de"));
      // console.log(des);

      // 7. sort Exercise
      // Sort the people alphabetically by last name
      // let sortedPeople = people.sort((a, b) => a.localeCompare(b));
      let sortedData = people.sort((lastOne, nextOne) => {
        const [aLast, aFirst] = lastOne.split(", ");
        const [bLast, bFirst] = nextOne.split(", ");
        return aLast > bLast ? 1 : -1;
      });

      // console.log(sortedPeople);

      // 8. Reduce Exercise
      // Sum up the instances of each of these
      // 센스 넘치는 부분
      const data = [
        "car",
        "car",
        "truck",
        "truck",
        "bike",
        "walk",
        "car",
        "van",
        "bike",
        "walk",
        "car",
        "van",
        "car",
        "truck",
        "pogostick",
      ];

      const result = data.reduce((obj, item) => {
        if (!obj[item]) obj[item] = 0;
        ++obj[item];
        return obj;
      }, {});

      console.log(result);
    </script>
  </body>
</html>
